from pwn import *
from gmpy2 import iroot
io = remote("34.173.236.50","49100")
io.readuntil(b'c =')
ct = int(io.readline().strip())
io.readuntil(b'n =')
n = int(io.readline().strip())
io.readuntil(b'phi =')
phi = int(io.readline().strip())
e = 65537
private = pow(e,-1,phi)
message = hex(pow(ct,private,n))[2:]
a = 1
b = -(n+1-phi)
c = n
d = pow(b,2) - 4*a*c
p = (-b - iroot(d,2)[0])//(2*a)
q = n//p
assert n == p*q
io.sendline(str(p).encode())
io.sendline(str(q).encode())
io.sendline(str(message).encode())
io.readuntil(b"Enter p: Enter q: Enter the secret message as hex: ")
flag = io.readline().strip()
print(flag)